CREATE TABLE `T59ahl7_snippets` (  `id` bigint(20) NOT NULL AUTO_INCREMENT,  `name` tinytext NOT NULL,  `description` text NOT NULL,  `code` longtext NOT NULL,  `tags` longtext NOT NULL,  `scope` varchar(15) NOT NULL DEFAULT 'global',  `priority` smallint(6) NOT NULL DEFAULT 10,  `active` tinyint(1) NOT NULL DEFAULT 0,  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  PRIMARY KEY (`id`),  KEY `scope` (`scope`),  KEY `active` (`active`)) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;
/*!40000 ALTER TABLE `T59ahl7_snippets` DISABLE KEYS */;
SET FOREIGN_KEY_CHECKS = 0;
SET UNIQUE_CHECKS = 0;
INSERT INTO `T59ahl7_snippets` VALUES('1', 'Make upload filenames lowercase', 'Makes sure that image and file uploads have lowercase filenames.\n\nThis is a sample snippet. Feel free to use it, edit it, or remove it.', 'add_filter( \'sanitize_file_name\', \'mb_strtolower\' );', 'sample, media', 'global', '10', '0', '2023-04-10 16:25:51');
INSERT INTO `T59ahl7_snippets` VALUES('2', 'Disable admin bar', 'Turns off the WordPress admin bar for everyone except administrators.\n\nThis is a sample snippet. Feel free to use it, edit it, or remove it.', 'add_action( \'wp\', function () {\n	if ( ! current_user_can( \'manage_options\' ) ) {\n		show_admin_bar( false );\n	}\n} );', 'sample, admin-bar', 'front-end', '10', '0', '2023-04-10 16:25:51');
INSERT INTO `T59ahl7_snippets` VALUES('3', 'Allow smilies', 'Allows smiley conversion in obscure places.\n\nThis is a sample snippet. Feel free to use it, edit it, or remove it.', 'add_filter( \'widget_text\', \'convert_smilies\' );\nadd_filter( \'the_title\', \'convert_smilies\' );\nadd_filter( \'wp_title\', \'convert_smilies\' );\nadd_filter( \'get_bloginfo\', \'convert_smilies\' );', 'sample', 'global', '10', '0', '2023-04-10 16:25:51');
INSERT INTO `T59ahl7_snippets` VALUES('4', 'Current year', 'Shortcode for inserting the current year into a post or page..\n\nThis is a sample snippet. Feel free to use it, edit it, or remove it.', '<?php echo date( \'Y\' ); ?>', 'sample, dates', 'content', '10', '0', '2023-04-10 16:25:51');
INSERT INTO `T59ahl7_snippets` VALUES('5', 'Ensure Webfont is Loaded', '', 'add_filter( \'elementor_pro/custom_fonts/font_display\', function( $current_value, $font_family, $data ) {\n	return \'swap\';\n}, 10, 3 );', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('6', 'Explicit Fixed Width and Height', '', 'add_filter( \'the_content\', \'add_image_dimensions\' );\n\nfunction add_image_dimensions( $content ) {\n\n    preg_match_all( \'/<img[^>]+>/i\', $content, $images);\n\n    if (count($images) < 1)\n        return $content;\n\n    foreach ($images[0] as $image) {\n        preg_match_all( \'/(alt|title|src|width|class|id|height)=(\"[^\"]*\")/i\', $image, $img );\n\n        if ( !in_array( \'src\', $img[1] ) )\n            continue;\n\n        if ( !in_array( \'width\', $img[1] ) || !in_array( \'height\', $img[1] ) ) {\n            $src = $img[2][ array_search(\'src\', $img[1]) ];\n            $alt = in_array( \'alt\', $img[1] ) ? \' alt=\' . $img[2][ array_search(\'alt\', $img[1]) ] : \'\';\n            $title = in_array( \'title\', $img[1] ) ? \' title=\' . $img[2][ array_search(\'title\', $img[1]) ] : \'\';\n            $class = in_array( \'class\', $img[1] ) ? \' class=\' . $img[2][ array_search(\'class\', $img[1]) ] : \'\';\n            $id = in_array( \'id\', $img[1] ) ? \' id=\' . $img[2][ array_search(\'id\', $img[1]) ] : \'\';\n            list( $width, $height, $type, $attr ) = getimagesize( str_replace( \"\\\"\", \"\" , $src ) );\n\n            $image_tag = sprintf( \'<img src=%s%s%s%s%s width=\"%d\" height=\"%d\" />\', $src, $alt, $title, $class, $id, $width, $height );\n            $content = str_replace($image, $image_tag, $content);\n        }\n    }\n\n    return $content;\n}', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('7', 'Purge your Site', '', '/*\nPlugin Name: Purge Cache\nDescription: Adds a button to the WordPress dashboard to clear the object cache\n*/\n\nadd_action( \'admin_bar_menu\', \'add_purge_cache_button\', 999 );\n\nfunction add_purge_cache_button( $wp_admin_bar ) {\n    if ( ! current_user_can( \'manage_options\' ) ) {\n        return;\n    }\n\n    $args = array(\n        \'id\'    => \'purge-cache\',\n        \'title\' => \'Purge Cache\',\n        \'href\'  => \'#\',\n        \'meta\'  => array( \'class\' => \'purge-cache\' )\n    );\n    $wp_admin_bar->add_node( $args );\n}\n\nadd_action( \'admin_footer\', \'add_purge_cache_script\' );\n\nfunction add_purge_cache_script() {\n    if ( ! current_user_can( \'manage_options\' ) ) {\n        return;\n    }\n    ?>\n    <script>\n    jQuery(document).ready(function($) {\n        $(\'#wp-admin-bar-purge-cache\').click(function() {\n            if (confirm(\'Are you sure you want to purge the cache?\')) {\n                $.ajax({\n                    url: \'<?php echo admin_url( \'admin-ajax.php\' ); ?>\',\n                    data: {\n                        action: \'purge_cache\',\n                    },\n                    success: function() {\n                        alert(\'Cache purged successfully!\');\n                    },\n                    error: function() {\n                        alert(\'An error occurred while purging the cache.\');\n                    }\n                });\n            }\n        });\n    });\n    </script>\n    <?php\n}\n\nadd_action( \'wp_ajax_purge_cache\', \'purge_cache_callback\' );\n\nfunction purge_cache_callback() {\n    global $wp_object_cache;\n    if ( ! current_user_can( \'manage_options\' ) ) {\n        wp_die();\n    }\n\n    wp_cache_flush();\n\n    wp_die();\n}', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('8', 'Remove Google Fonts', '', 'add_filter( \'elementor/frontend/print_google_fonts\', \'__return_false\' );', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('9', 'Remove Gutenberg CSS', '', '//Remove Gutenberg Block Library CSS from loading on the frontend\nfunction smartwp_remove_wp_block_library_css(){\n wp_dequeue_style( \'wp-block-library\' );\n wp_dequeue_style( \'wp-block-library-theme\' );\n}\nadd_action( \'wp_enqueue_scripts\', \'smartwp_remove_wp_block_library_css\' );', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('10', 'Remove Unused JS', '', '/**\n * We will Dequeue the jQuery UI script as example.\n *\n * Hooked to the wp_print_scripts action, with a late priority (99),\n * so that it is after the script was enqueued.\n */\nfunction wp_remove_scripts() {\n// check if user is admina\n if (current_user_can( \'update_core\' )) {\n            return;\n        } \n else {\n    // Check for the page you want to target\n    if ( is_page( \'homepage\' ) ) {\n        // Remove Scripts\n  wp_dequeue_style( \'jquery-ui-core\' );\n     }\n }\n}\nadd_action( \'wp_enqueue_scripts\', \'wp_remove_scripts\', 99 );', '', 'global', '10', '1', '2023-04-10 16:26:15');
INSERT INTO `T59ahl7_snippets` VALUES('11', 'Stop Lazy Load', '', 'add_filter( \'wp_lazy_loading_enabled\', \'__return_false\' );', '', 'global', '10', '1', '2023-04-10 16:26:15');
/*!40000 ALTER TABLE `T59ahl7_snippets` ENABLE KEYS */;
SET FOREIGN_KEY_CHECKS = 1;
SET UNIQUE_CHECKS = 1;
